-------------
-- Tooltip --
-------------
local TooltipItem = function(self, ...)
	local name, link = self:GetItem();
	if(link) then
		local _, _, quality, itemLevel, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(link)
		local _, itemID = strsplit(":", link)
		PA_KeyBinding = {
			[1] = true;
			[2] = IsShiftKeyDown();
			[3] = IsControlKeyDown();
			[4] = IsAltKeyDown();
		}
		----------------
		-- Herbs part --
		----------------
		if(MillingButton:GetChecked() and MillingButton:IsEnabled() and PA_KeyBinding[MillingID]) then
			for HerbID, HerbResult in pairs(T_Herb) do
				if(itemID == HerbID) then
					local r,g,b = 0,1,0.5
					self:AddLine(" ")
					self:AddLine("Milling result:  "..HerbResult[1][1],r,g,b)
					
					for _,Value in ipairs(HerbResult) do
						for i=1,#Value-1,1 do
							if(type(Value[i]) == 'number') then
								self:AddLine(T_Milling[Value[i]]..Value[#Value],r,g,b)
							end
						end
					end
				end
			end
			for PigmentID, PigmentResult in pairs(T_Pigments) do
				if(itemID == PigmentID) then
					local r,g,b = 0,1,0.5
					self:AddLine(" ")
					self:AddLine("Milled from:  "..PigmentResult[1][1],r,g,b)
					
					for _,Value in ipairs(PigmentResult) do
						for i=1,#Value-1,1 do
							if(type(Value[i]) == 'number') then
								self:AddLine(T_Herb2[Value[i]]..Value[#Value],r,g,b)
							end
						end
					end
				end
			end
		end
		----------------------
		-- Prospecting part --
		----------------------
		if(ProspectingButton:GetChecked() and ProspectingButton:IsEnabled() and PA_KeyBinding[ProspectingID]) then
			for OreID, OreResult in pairs(T_Ores) do
				if(itemID == OreID) then
					local r,g,b = 1,0.5,0
					self:AddLine(" ")
					self:AddLine("Prospecting result:  "..OreResult[1][1],r,g,b)
					
					for _,Value in ipairs(OreResult) do
						for i=1,#Value-1,1 do
							if(type(Value[i]) == 'number') then
								self:AddLine(T_Pros[Value[i]]..Value[#Value],r,g,b)
							end
						end
					end
				end
			end
			for GemID, GemResult in pairs(T_Gems) do
				if(itemID == GemID) then
					local r,g,b = 1,0.5,0
					self:AddLine(" ")
					self:AddLine("Prospected from:  "..GemResult[1][1],r,g,b)
					
					for _,Value in ipairs(GemResult) do
						for i=1,#Value-1,1 do
							if(type(Value[i]) == 'number') then
								self:AddLine(T_Ores2[Value[i]]..Value[#Value],r,g,b)
							end
						end
					end
				end
			end
		end
		---------------------
		-- Enchanting part --
		---------------------
		if(EnchantingButton:GetChecked() and EnchantingButton:IsEnabled() and PA_KeyBinding[EnchantingID]) then
			if(not(itemEquipLoc=="" or itemEquipLoc==_G["INVTYPE_BODY"] or itemEquipLoc==_G["INVTYPE_RELIC"] or
			itemEquipLoc==_G["INVTYPE_TABARD"] or itemEquipLoc==_G["INVTYPE_BAG"] or itemEquipLoc==_G["INVTYPE_QUIVER"] or itemSubType==_G["MISCELLANEOUS"])) then
				for _,ItemLevel in ipairs(T_iLvl) do
					for num=ItemLevel[1], ItemLevel[2],1 do
						if(itemLevel==num) then
							local r,g,b = 1,0,0.9
							if(quality==2) then
								if(itemType==_G["ARMOR"]) then
									self:AddLine(" ")
									self:AddLine("Disenchanting result:  "..ItemLevel[3][1][1],r,g,b)
									for Key,Result in ipairs(ItemLevel[3]) do
										if not(Key==1) then
											self:AddLine(Result[1],r,g,b)
										end
									end
								end
								if(itemType==_G["WEAPON"]) then
									self:AddLine(" ")
									self:AddLine("Disenchanting result:  "..ItemLevel[3][1][1],r,g,b)
									for Key,Result in ipairs(ItemLevel[4]) do
										self:AddLine(Result[1],r,g,b)
									end
								end
							end
						end
					end
					if(type(ItemLevel[5]) == "number") then
						for num=ItemLevel[5], ItemLevel[6],1 do
							if(itemLevel==num) then
								local r,g,b = 1,0,0.9
								if(quality==3 and (itemType==_G["ARMOR"] or itemType==_G["WEAPON"])) then
									self:AddLine(" ")
									self:AddLine("Disenchanting result:  "..ItemLevel[7][1][1],r,g,b)
									for Key,Result in ipairs(ItemLevel[7]) do
										if not(Key==1) then
											if not(string.find(name,"Contender's")) then
												self:AddLine(Result[1],r,g,b)
											else
												self:AddLine(Result[2],r,g,b)
											end
										end
									end	
								end
							end
						end
					end
					if(type(ItemLevel[8]) == "number") then
						for num=ItemLevel[8], ItemLevel[9],1 do
							if(itemLevel==num) then
								local r,g,b = 1,0,0.9
								if(quality==4 and (itemType==_G["ARMOR"] or itemType==_G["WEAPON"])) then
									self:AddLine(" ")
									self:AddLine("Disenchanting result:  "..ItemLevel[10][1][1],r,g,b)
									for Key,Result in ipairs(ItemLevel[10]) do
										if not(Key==1) then
											self:AddLine(Result[1],r,g,b)
										end
									end	
								end
							end
						end
					end
				end
			end
			for DisID,DisResult in pairs(T_Dis) do
				if(itemID == DisID) then
					local r,g,b = 1,0,0.9
					self:AddLine(" ")
					self:AddLine("Disenchanted from:  "..DisResult[1],r,g,b)
					
					self:AddLine(DisResult[2],r,g,b)
					self:AddLine("Gear quality: "..DisResult[3],r,g,b)
					self:AddLine("Chance from armor:"..DisResult[4].."|r",r,g,b)
					self:AddLine("Chance from weapon:"..DisResult[5].."|r",r,g,b)
				end
			end
		end
	end
end
	
for _, obj in next, {
	GameTooltip,
	ShoppingTooltip1,
	ShoppingTooltip2,
	ShoppingTooltip3,
	ItemRefTooltip,
} do
	obj:HookScript("OnTooltipSetItem", TooltipItem)
end